package org.mortbay.cometd.ext;

import java.util.Map;

import org.cometd.Bayeux;
import org.cometd.Client;
import org.cometd.Extension;
import org.cometd.Message;
import org.mortbay.log.Log;
import org.mortbay.util.ajax.JSON;

public class AcknowledgedMessagesExtension implements Extension
{
    JSON.Literal _replyExt = new JSON.Literal("{\"ack\":\"true\"}");
    
    public Message rcv(Client from, Message message)
    {
        return message;
    }

    public Message rcvMeta(Client from, Message message)
    {
        return message;
    }

    public Message send(Client from, Message message)
    {
        return message;
    }

    public Message sendMeta(Client from, Message message)
    {
        if (message.getChannel().equals(Bayeux.META_HANDSHAKE) && Boolean.TRUE.equals(message.get(Bayeux.SUCCESSFUL_FIELD)))
        {
            Message rcv = message.getAssociated();
            
            Map<String, Object> ext = rcv.getExt(false);
            boolean clientRequestedAcks = ext != null && ext.get("ack") != null;

            if (clientRequestedAcks && from!=null) {
                Log.info("Enabled message acknowledgement for client " + from);
                from.addExtension(new AcknowledgedMessagesClientExtension());
            }
            
            message.put(Bayeux.EXT_FIELD, _replyExt);
        }

        return message;
    }

}
